/* Autogenerated by ../bin/halcompile on Tue Jul  4 11:30:54 2017 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:bldc_hall3:3-wire BLDC motor driver using Hall sensors and trapezoidal commutation.\nThe functionality of this component is now included in the generic \"bldc\" \ncomponent. This component is likely to be removed in a future release");
MODULE_INFO(linuxcnc, "pin:hall1:bit:0:in:Hall sensor signal 1:None:None");
MODULE_INFO(linuxcnc, "pin:hall2:bit:0:in:Hall sensor signal 2:None:None");
MODULE_INFO(linuxcnc, "pin:hall3:bit:0:in:Hall sensor signal 3:None:None");
MODULE_INFO(linuxcnc, "pin:value:float:0:in:PWM master amplitude input:None:None");
MODULE_INFO(linuxcnc, "pin:dir:bit:0:in:Forwards / reverse selection. Negative PWM amplitudes will also \nreverse the motor and there will generally be a pattern that runs the motor in\neach direction too.:None:None");
MODULE_INFO(linuxcnc, "pin:A-value:float:0:out:Output amplitude for phase A:None:None");
MODULE_INFO(linuxcnc, "pin:B-value:float:0:out:Output amplitude for phase B:None:None");
MODULE_INFO(linuxcnc, "pin:C-value:float:0:out:Output amplitude for phase C:None:None");
MODULE_INFO(linuxcnc, "param:pattern:u32:0:rw:Commutation pattern to use, from 0 to 47. Default is type 25.\nEvery plausible combination is included. The table shows the excitation pattern\nalong the top, and the pattern code on the left hand side. The table entries\nare the hall patterns in H1, H2, H3 order. \nCommon patterns are:\n0 (30 degree commutation) and 26, its reverse. \n17 (120 degree).\n18 (alternate 60 degree).\n21 (300 degree, Bodine).\n22 (240 degree).\n25 (60 degree commutation).\n\nNote that a number of incorrect commutations will have non-zero net torque \nwhich might look as if they work, but don't really. \n\nIf your motor lacks documentation it might be worth trying every pattern. \n\n.ie '\\*[.T]'html' \\{\\\n.HTML \\\n<STYLE> \\\n#pattern TD { text-align: center; padding-left: .5ex; padding-right: .5ex } \\\n#pattern TH { text-align: center; padding-left: .5ex; padding-right: .5ex } \\\n#pattern TD.W { text-align: right; } \\\n</STYLE> \\\n<TABLE ID=\"pattern\" STYLE=\"border: 1px solid black; border-collapse: collapse\"> \\\n<COL SPAN=7 STYLE=\"margin: .2ex\"><COL SPAN=1 STYLE=\"border-left: 1px solid black\"> \\\n<TR><TD>&nbsp;<TH COLSPAN=6 CLASS=W>Phases, Source - Sink \\\n<TR><TH CLASS=W>pat<TH CLASS=W>B-A<TH CLASS=W>C-A<TH CLASS=W>C-B<TH CLASS=W>A-B<TH CLASS=W>A-C<TH CLASS=W>B-C \\\n<TR><TH>0<TD>000<TD>001<TD>011<TD>111<TD>110<TD>100 \\\n<TR><TH>1<TD>001<TD>000<TD>010<TD>110<TD>111<TD>101 \\\n<TR><TH>2<TD>000<TD>010<TD>011<TD>111<TD>101<TD>100 \\\n<TR><TH>3<TD>001<TD>011<TD>010<TD>110<TD>100<TD>101 \\\n<TR><TH>4<TD>010<TD>011<TD>001<TD>101<TD>100<TD>110 \\\n<TR><TH>5<TD>011<TD>010<TD>000<TD>100<TD>101<TD>111 \\\n<TR><TH>6<TD>010<TD>000<TD>001<TD>101<TD>111<TD>110 \\\n<TR><TH>7<TD>011<TD>001<TD>000<TD>100<TD>110<TD>111 \\\n<TR><TH>8<TD>000<TD>001<TD>101<TD>111<TD>110<TD>010 \\\n<TR><TH>9<TD>001<TD>000<TD>100<TD>110<TD>111<TD>011 \\\n<TR><TH>10<TD>000<TD>010<TD>110<TD>111<TD>101<TD>001 \\\n<TR><TH>11<TD>001<TD>011<TD>111<TD>110<TD>100<TD>000 \\\n<TR><TH>12<TD>010<TD>011<TD>111<TD>101<TD>100<TD>000 \\\n<TR><TH>13<TD>011<TD>010<TD>110<TD>100<TD>101<TD>001 \\\n<TR><TH>14<TD>010<TD>000<TD>100<TD>101<TD>111<TD>011 \\\n<TR><TH>15<TD>011<TD>001<TD>101<TD>100<TD>110<TD>010 \\\n<TR><TH>16<TD>000<TD>100<TD>101<TD>111<TD>011<TD>010 \\\n<TR><TH>17<TD>001<TD>101<TD>100<TD>110<TD>010<TD>011 \\\n<TR><TH>18<TD>000<TD>100<TD>110<TD>111<TD>011<TD>001 \\\n<TR><TH>19<TD>001<TD>101<TD>111<TD>110<TD>010<TD>000 \\\n<TR><TH>20<TD>010<TD>110<TD>111<TD>101<TD>001<TD>000 \\\n<TR><TH>21<TD>011<TD>111<TD>110<TD>100<TD>000<TD>001 \\\n<TR><TH>22<TD>010<TD>110<TD>100<TD>101<TD>001<TD>011 \\\n<TR><TH>23<TD>011<TD>111<TD>101<TD>100<TD>000<TD>010 \\\n<TR><TH>24<TD>100<TD>101<TD>111<TD>011<TD>010<TD>000 \\\n<TR><TH>25<TD>101<TD>100<TD>110<TD>010<TD>011<TD>001 \\\n<TR><TH>26<TD>100<TD>110<TD>111<TD>011<TD>001<TD>000 \\\n<TR><TH>27<TD>101<TD>111<TD>110<TD>010<TD>000<TD>001 \\\n<TR><TH>28<TD>110<TD>111<TD>101<TD>001<TD>000<TD>010 \\\n<TR><TH>29<TD>111<TD>110<TD>100<TD>000<TD>001<TD>011 \\\n<TR><TH>30<TD>110<TD>100<TD>101<TD>001<TD>011<TD>010 \\\n<TR><TH>31<TD>111<TD>101<TD>100<TD>000<TD>010<TD>011 \\\n<TR><TH>32<TD>100<TD>101<TD>001<TD>011<TD>010<TD>110 \\\n<TR><TH>33<TD>101<TD>100<TD>000<TD>010<TD>011<TD>111 \\\n<TR><TH>34<TD>100<TD>110<TD>010<TD>011<TD>001<TD>101 \\\n<TR><TH>35<TD>101<TD>111<TD>011<TD>010<TD>000<TD>100 \\\n<TR><TH>36<TD>110<TD>111<TD>011<TD>001<TD>000<TD>100 \\\n<TR><TH>37<TD>111<TD>110<TD>010<TD>000<TD>001<TD>101 \\\n<TR><TH>38<TD>110<TD>100<TD>000<TD>001<TD>011<TD>111 \\\n<TR><TH>39<TD>111<TD>101<TD>001<TD>000<TD>010<TD>110 \\\n<TR><TH>40<TD>100<TD>000<TD>001<TD>011<TD>111<TD>110 \\\n<TR><TH>41<TD>101<TD>001<TD>000<TD>010<TD>110<TD>111 \\\n<TR><TH>42<TD>100<TD>000<TD>010<TD>011<TD>111<TD>101 \\\n<TR><TH>43<TD>101<TD>001<TD>011<TD>010<TD>110<TD>100 \\\n<TR><TH>44<TD>110<TD>010<TD>011<TD>001<TD>101<TD>100 \\\n<TR><TH>45<TD>111<TD>011<TD>010<TD>000<TD>100<TD>101 \\\n<TR><TH>46<TD>110<TD>010<TD>000<TD>001<TD>101<TD>111 \\\n<TR><TH>47<TD>111<TD>011<TD>001<TD>000<TD>100<TD>110 \\\n</TABLE>\n\\}\n.el \\{\\\n\n.TS\nbox tab(;);\ncb s s s s s s\ncb|cb cb cb cb cb cb\nc | c  c  c  c c r.\nPhases, Source - Sink\n_\npat;B-A;C-A;C-B;A-B;A-C;B-C\n_\n0;000;001;011;111;110;100\n1;001;000;010;110;111;101\n2;000;010;011;111;101;100\n3;001;011;010;110;100;101\n4;010;011;001;101;100;110\n5;011;010;000;100;101;111\n6;010;000;001;101;111;110\n7;011;001;000;100;110;111\n8;000;001;101;111;110;010\n9;001;000;100;110;111;011\n10;000;010;110;111;101;001\n11;001;011;111;110;100;000\n12;010;011;111;101;100;000\n13;011;010;110;100;101;001\n14;010;000;100;101;111;011\n15;011;001;101;100;110;010\n16;000;100;101;111;011;010\n17;001;101;100;110;010;011\n18;000;100;110;111;011;001\n19;001;101;111;110;010;000\n20;010;110;111;101;001;000\n21;011;111;110;100;000;001\n22;010;110;100;101;001;011\n23;011;111;101;100;000;010\n24;100;101;111;011;010;000\n25;101;100;110;010;011;001\n26;100;110;111;011;001;000\n27;101;111;110;010;000;001\n28;110;111;101;001;000;010\n29;111;110;100;000;001;011\n30;110;100;101;001;011;010\n31;111;101;100;000;010;011\n32;100;101;001;011;010;110\n33;101;100;000;010;011;111\n34;100;110;010;011;001;101\n35;101;111;011;010;000;100\n36;110;111;011;001;000;100\n37;111;110;010;000;001;101\n38;110;100;000;001;011;111\n39;111;101;001;000;010;110\n40;100;000;001;011;111;110\n41;101;001;000;010;110;111\n42;100;000;010;011;111;101\n43;101;001;011;010;110;100\n44;110;010;011;001;101;100\n45;111;011;010;000;100;101\n46;110;010;000;001;101;111\n47;111;011;001;000;100;110\n.TE\n\\}\n:25:None");
MODULE_INFO(linuxcnc, "descr:\nThis component produces a 3-wire bipolar output. This suits upstream drivers \nthat interpret a negative input as a low-side drive and positive as a high-side \ndrive. This includes the Hostmot2 3pwmgen function, which is likely to be the \nmost common application of this component. \n");
MODULE_INFO(linuxcnc, "see_also:\nbldc_hall6 6-wire unipolar driver for BLDC motors.\n");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Andy Pugh");
MODULE_INFO(linuxcnc, "funct:_:1:Interpret Hall sensor patterns and set 3-phase amplitudes");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *hall1;
    hal_bit_t *hall2;
    hal_bit_t *hall3;
    hal_float_t *value;
    hal_bit_t *dir;
    hal_float_t *A_value;
    hal_float_t *B_value;
    hal_float_t *C_value;
    hal_u32_t pattern;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_bit_newf(HAL_IN, &(inst->hall1), comp_id,
        "%s.hall1", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->hall2), comp_id,
        "%s.hall2", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->hall3), comp_id,
        "%s.hall3", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->value), comp_id,
        "%s.value", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->dir), comp_id,
        "%s.dir", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->A_value), comp_id,
        "%s.A-value", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->B_value), comp_id,
        "%s.B-value", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->C_value), comp_id,
        "%s.C-value", prefix);
    if(r != 0) return r;
    r = hal_param_u32_newf(HAL_RW, &(inst->pattern), comp_id,
        "%s.pattern", prefix);
    inst->pattern = 25;
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
char *names[16] = {0,};
RTAPI_MP_INT(count, "number of bldc_hall3");
RTAPI_MP_ARRAY_STRING(names, 16, "names of bldc_hall3");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("bldc_hall3");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "bldc-hall3.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        int max_names = sizeof(names)/sizeof(names[0]);
        for(i=0; (i < max_names) && names[i]; i++) {
            if (strlen(names[i]) < 1) {
                rtapi_print_msg(RTAPI_MSG_ERR, "names[%d] is invalid (empty string)\n", i);
                r = -EINVAL;
                break;
            }
            r = export(names[i], i);
            if(r != 0) break;
       }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef hall1
#define hall1 (0+*__comp_inst->hall1)
#undef hall2
#define hall2 (0+*__comp_inst->hall2)
#undef hall3
#define hall3 (0+*__comp_inst->hall3)
#undef value
#define value (0+*__comp_inst->value)
#undef dir
#define dir (0+*__comp_inst->dir)
#undef A_value
#define A_value (*__comp_inst->A_value)
#undef B_value
#define B_value (*__comp_inst->B_value)
#undef C_value
#define C_value (*__comp_inst->C_value)
#undef pattern
#define pattern (__comp_inst->pattern)


#line 179 "hal/components/bldc_hall3.comp"

/*dir H1 H2 H3 pattern 
000  001  010  011  100  101  110  111 */
static unsigned int P[]={
024, 014, 000, 012, 021, 000, 041, 042,
014, 024, 012, 000, 000, 021, 042, 041,
024, 000, 014, 012, 021, 041, 000, 042,
000, 024, 012, 014, 041, 021, 042, 000,
000, 012, 024, 014, 041, 042, 021, 000,
012, 000, 014, 024, 042, 041, 000, 021,
014, 012, 024, 000, 000, 042, 021, 041,
012, 014, 000, 024, 042, 000, 041, 021,
024, 014, 021, 000, 000, 012, 041, 042,
014, 024, 000, 021, 012, 000, 042, 041,
024, 021, 014, 000, 000, 041, 012, 042,
021, 024, 000, 014, 041, 000, 042, 012,
021, 000, 024, 014, 041, 042, 000, 012,
000, 021, 014, 024, 042, 041, 012, 000,
014, 000, 024, 021, 012, 042, 000, 041,
000, 014, 021, 024, 042, 012, 041, 000,
024, 000, 021, 041, 014, 012, 000, 042,
000, 024, 041, 021, 012, 014, 042, 000,
024, 021, 000, 041, 014, 000, 012, 042,
021, 024, 041, 000, 000, 014, 042, 012,
021, 041, 024, 000, 000, 042, 014, 012,
041, 021, 000, 024, 042, 000, 012, 014,
000, 041, 024, 021, 012, 042, 014, 000,
041, 000, 021, 024, 042, 012, 000, 014,
021, 000, 041, 042, 024, 014, 000, 012,
000, 021, 042, 041, 014, 024, 012, 000,
021, 041, 000, 042, 024, 000, 014, 012,
041, 021, 042, 000, 000, 024, 012, 014,
041, 042, 021, 000, 000, 012, 024, 014,
042, 041, 000, 021, 012, 000, 014, 024,
000, 042, 021, 041, 014, 012, 024, 000,
042, 000, 041, 021, 012, 014, 000, 024,
000, 012, 041, 042, 024, 014, 021, 000,
012, 000, 042, 041, 014, 024, 000, 021,
000, 041, 012, 042, 024, 021, 014, 000,
041, 000, 042, 012, 021, 024, 000, 014,
041, 042, 000, 012, 021, 000, 024, 014,
042, 041, 012, 000, 000, 021, 014, 024,
012, 042, 000, 041, 014, 000, 024, 021,
042, 012, 041, 000, 000, 014, 021, 024,
014, 012, 000, 042, 024, 000, 021, 041,
012, 014, 042, 000, 000, 024, 041, 021,
014, 000, 012, 042, 024, 021, 000, 041,
000, 014, 042, 012, 021, 024, 041, 000,
000, 042, 014, 012, 021, 041, 024, 000,
042, 000, 012, 014, 041, 021, 000, 024,
012, 042, 014, 000, 000, 041, 024, 021,
042, 012, 000, 014, 041, 000, 021, 024};

FUNCTION(_){
    int i;
    double V;
    if (pattern > 47){
        rtapi_print_msg(RTAPI_MSG_ERR, 
        "Only step patterns 0-47 are allowed, you have requested pattern %i\n",
        pattern);
        pattern = 0;
        return;
    }
    
    i  = (pattern << 3) + (hall1 << 2) + (hall2 << 1) + hall3;
	
    if (dir) V = -value;
    else V = value;
	
    if (P[i] & 040) A_value =V;
    else if (P[i] & 004) A_value = -V;
    else A_value = 0;

    if (P[i] & 020) B_value = V;
    else if (P[i] & 002) B_value = -V;
    else B_value = 0;

    if (P[i] & 010) C_value = V;
    else if (P[i] & 001) C_value = -V;
    else C_value = 0;
}


static int __comp_get_data_size(void) { return 0; }
